# JJ 2019-02-18: ticket cache checks and home directory population
if [ "$HOME" = "/home/$USER" ] && 
    [ "x$HYADHOME" = x ] && 
    [ $(id -u) -gt 1000000 ]; then

  # Use the CIFS DFS mount as HYADHOME
  c=$(echo "$USER" | cut -c1)
  export HYADHOME=/home/ad/home/$c/$USER
  unset c
  
  if [ -e /etc/cubbli/flags/use-ad-home -a "x$KRB5CCNAME" = "x" ]; then
    uid=$(id -u)
    # Try to make sure that we have a kerberos ticket cache.
    unset KRB5CCNAME
    for ticket in "/tmp/krb5cc_${uid}_"* ; do
      # Check for symlink and file name trickery
      if [ "$(stat --format "%F %u" $ticket 2>/dev/null)" = "regular file $uid" ]; then
        export KRB5CCNAME=FILE:$ticket
	# Check correct kerberos domain for HYAD
	if ! klist | fgrep -q "krbtgt/AD.HELSINKI.FI@AD.HELSINKI.FI"; then
	  continue
	fi
	# use the ticket, if it can be renewed for 5 minutes
	krenew -H 5 && break
	unset KRB5CCNAME
      fi
    done
    unset ticket
    unset uid

    if [ "x$KRB5CCNAME" = "x" ]; then
      echo "You have succesfully logged in, but don't have a valid Kerberos ticket."
      echo "More details here: https://wiki.helsinki.fi/x/8YbLDw"
      echo "Login with your AD password to get a new Kerberos ticket:"
      export KRB5CCNAME=$(ssh -a -k -o "StrictHostKeyChecking off" -o "UserKnownHostsFile /dev/null"  $(uname -n) 'echo $KRB5CCNAME' 2>/dev/null)
    fi

    if [ "x$KRB5CCNAME" = "x" ]; then
      echo "Failed to get a kerberos ticket. Logging you out now."
      exit 1
    fi
    # Now this might work
    cd
  fi

  # This populates Cubbli home directory
  /usr/bin/cubbli-home-dir populate
  # Source Cubbli configuration if any
  [ -e $HOME/.cubbli ] && . $HOME/.cubbli
fi


if [ ! -f ~/.hushlogin ]; then
  cubbli-home-dir show
fi
